Index: /trunk/sources/HeuristicLab.DataAccess.ADOHelper/CachedDataAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess.ADOHelper/CachedDataAdapter.cs	(revision 1377)
+++ /trunk/sources/HeuristicLab.DataAccess.ADOHelper/CachedDataAdapter.cs	(revision 1377)
@@ -0,0 +1,272 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Data;
+using System.Threading;
+using HeuristicLab.DataAccess.Interfaces;
+
+namespace HeuristicLab.DataAccess.ADOHelper {
+  public abstract class CachedDataAdapter<AdapterT, ObjT, RowT, CacheT> :
+    DataAdapterBase<AdapterT, ObjT, RowT>,
+    ICachedDataAdapter
+    where CacheT : System.Data.TypedTableBase<RowT>, new()
+    where AdapterT : new()
+    where RowT : System.Data.DataRow
+    where ObjT : IPersistableObject, new() {
+    protected static CacheT cache =
+      new CacheT();
+
+    private static bool cacheFilled = false;
+
+    private static ReaderWriterLockSlim cacheLock =
+      new ReaderWriterLockSlim(LockRecursionPolicy.SupportsRecursion);
+
+    protected ICollection<ICachedDataAdapter> parentAdapters =
+      new List<ICachedDataAdapter>();
+
+    protected CachedDataAdapter(IDBSynchronizer synchronizer) {
+      cacheLock.EnterWriteLock();
+
+      if (!cacheFilled) {
+        FillCache();
+        cacheFilled = true;
+      }
+
+      cacheLock.ExitWriteLock();
+
+      synchronizer.OnUpdate +=
+        new EventHandler(CachedDataAdapter_OnUpdate);
+    }
+
+    protected virtual RowT FindSingleRow(Selector dbSelector,
+      Selector cacheSelector) {
+      cacheLock.EnterReadLock();
+      
+      RowT row =
+         FindSingleRow(cacheSelector);
+
+      //not in cache
+      if (row == null) {
+        row =
+          FindSingleRow(dbSelector);
+      }
+
+      cacheLock.ExitReadLock();
+
+      return row;
+    }
+
+    protected virtual IEnumerable<RowT> FindMultipleRows(Selector dbSelector,
+        Selector cacheSelector) {
+      cacheLock.EnterReadLock();
+
+      IList<RowT> result =
+         new List<RowT>(cacheSelector());
+
+      IEnumerable<RowT> result2 =
+          dbSelector();
+
+      foreach (RowT row in result2) {
+        if (!IsCached(row)) {
+          result.Add(row);
+        }
+      }
+
+      cacheLock.ExitReadLock();
+
+      return result;
+    }
+
+    protected virtual ObjT FindSingle(Selector dbSelector,
+      Selector cacheSelector) {
+      ObjT obj = default(ObjT);
+
+      cacheLock.EnterReadLock();
+
+      RowT row = FindSingleRow(dbSelector, cacheSelector);
+
+      if (row != null) {
+        obj = new ObjT();
+        obj = Convert(row, obj);
+      }
+
+      cacheLock.ExitReadLock();
+
+      return obj;
+    }
+
+    protected virtual ICollection<ObjT> FindMultiple(Selector dbSelector,
+      Selector cacheSelector) {
+      cacheLock.EnterReadLock();
+
+      ICollection<ObjT> result =
+        FindMultiple(cacheSelector);
+
+      ICollection<ObjT> resultDb =
+        FindMultiple(dbSelector);
+
+      cacheLock.ExitReadLock();
+
+      foreach (ObjT obj in resultDb) {
+        if (!result.Contains(obj))
+          result.Add(obj);
+      }
+
+      return result;
+    }
+
+    protected abstract RowT InsertNewRowInCache(ObjT obj);
+
+    protected abstract void FillCache();
+
+    protected abstract void SynchronizeWithDb();
+
+    protected abstract bool PutInCache(ObjT obj);
+
+    protected abstract RowT FindCachedById(long id);
+
+    public void SyncWithDb() {
+      foreach (ICachedDataAdapter parent in this.parentAdapters) {        
+        parent.SyncWithDb();
+      }
+
+      cacheLock.EnterReadLock();
+
+      this.SynchronizeWithDb();
+
+      cacheLock.ExitReadLock();
+    }
+
+    void CachedDataAdapter_OnUpdate(object sender, EventArgs e) {
+      this.SyncWithDb();
+    }
+
+    protected virtual bool IsCached(RowT row) {
+      if (row == null)
+        return false;
+      else {
+        cacheLock.EnterReadLock();
+
+        bool cached = FindCachedById((long)row[row.Table.PrimaryKey[0]]) != null;
+
+        cacheLock.ExitReadLock();
+
+        return cached;
+      }
+    }
+
+    protected override RowT GetRowById(long id) {
+      cacheLock.EnterReadLock();
+
+      RowT row =
+        FindCachedById(id);
+
+      //not in cache
+      if (row == null)
+        row = FindSingleRow(
+          delegate() {
+            return FindById(id);
+          });
+
+      cacheLock.ExitReadLock();
+
+      return row;
+    }
+
+    private void AddToCache(RowT row) {
+      cacheLock.EnterWriteLock();
+
+      cache.ImportRow(row);
+      row.Table.Rows.Remove(row);
+
+      cacheLock.ExitWriteLock();
+    }
+
+    private RowT AddToCache(ObjT obj) {
+      cacheLock.EnterWriteLock();
+
+      RowT row =  InsertNewRowInCache(obj);
+
+      cacheLock.ExitWriteLock();
+
+      return row;
+    }
+
+    private void RemoveRowFromCache(RowT row) {
+      cacheLock.EnterWriteLock();
+
+      UpdateRow(row);
+
+      row.Table.Rows.Remove(row);     
+
+      cacheLock.ExitWriteLock();
+    }
+
+    public override void Update(ObjT obj) {
+      if (obj != null) {
+        RowT row = null;
+        long locked = default(long);
+
+        if (obj.Id != default(long)) {
+          LockRow(obj.Id);
+          locked = obj.Id;
+
+          row = GetRowById(obj.Id);
+        }
+
+        if (row == null) {
+          if (PutInCache(obj)) {
+            row = AddToCache(obj);
+          } else {
+            row = InsertNewRow(obj);
+          }
+
+          UpdateRow(row);
+          obj.Id = (long)row[row.Table.PrimaryKey[0]];
+        }
+
+        if (locked == default(long)) {
+          LockRow(obj.Id);
+          locked = obj.Id;
+        }
+
+        ConvertObj(obj, row);
+
+        if (!IsCached(row))
+          UpdateRow(row);
+
+        if (IsCached(row) &&
+            !PutInCache(obj)) {          
+          RemoveRowFromCache(row);
+        } else if (!IsCached(row) &&
+          PutInCache(obj)) {
+          AddToCache(row);
+        }
+
+        UnlockRow(locked);
+      }
+    }
+  }
+}
+
Index: /trunk/sources/HeuristicLab.DataAccess.ADOHelper/DataAccessADOHelperPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess.ADOHelper/DataAccessADOHelperPlugin.cs	(revision 1377)
+++ /trunk/sources/HeuristicLab.DataAccess.ADOHelper/DataAccessADOHelperPlugin.cs	(revision 1377)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.DataAccess.ADOHelper {
+  [ClassInfo(Name = "HeuristicLab.DataAccess.ADOHelper-3.2")]
+  [PluginFile(Filename = "HeuristicLab.DataAccess.ADOHelper-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  public class DataAccessADOHelperPlugin : PluginBase {
+  }
+}
Index: /trunk/sources/HeuristicLab.DataAccess.ADOHelper/DataAdapterBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess.ADOHelper/DataAdapterBase.cs	(revision 1377)
+++ /trunk/sources/HeuristicLab.DataAccess.ADOHelper/DataAdapterBase.cs	(revision 1377)
@@ -0,0 +1,229 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Data;
+using System.Collections.Generic;
+using System.Text;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.DataAccess.Interfaces;
+
+namespace HeuristicLab.DataAccess.ADOHelper {
+  public abstract class DataAdapterBase<AdapterT, ObjT, RowT>
+    where AdapterT : new()
+    where RowT : System.Data.DataRow
+    where ObjT : IPersistableObject, new() {
+
+    private static Mutex lockersMutex =
+      new Mutex();
+
+    private static IDictionary<object, Mutex> lockers =
+      new Dictionary<object, Mutex>();
+
+    private static IDictionary<object, int> lockCount =
+      new Dictionary<object, int>();
+
+    protected void LockRow(object id) {
+      Mutex rowLock = null;
+
+      /////begin critical section////
+      lockersMutex.WaitOne();
+
+      if (!lockers.ContainsKey(id)) {
+        lockers[id] = new Mutex();
+        lockCount[id] = 0;
+      }
+      rowLock = lockers[id];
+      lockCount[id]++;
+      
+      lockersMutex.ReleaseMutex();
+      /////end critical section////
+
+      rowLock.WaitOne();
+    }
+
+    protected void UnlockRow(object id) {
+      Mutex rowLock = lockers[id];
+      rowLock.ReleaseMutex();
+
+      /////begin critical section////
+      lockersMutex.WaitOne();
+
+      lockCount[id]--;
+      if (lockCount[id] == 0)
+        lockers.Remove(id);
+
+      lockersMutex.ReleaseMutex();
+      /////end critical section////
+    }
+    
+    protected AdapterT Adapter {
+      get {
+        return new AdapterT();
+      }
+    }
+
+    #region Abstract methods
+    protected abstract RowT ConvertObj(ObjT obj, RowT row);
+
+    protected abstract ObjT ConvertRow(RowT row, ObjT obj);
+
+    protected abstract RowT InsertNewRow(ObjT obj);
+
+    protected abstract void UpdateRow(RowT row);
+
+    protected abstract IEnumerable<RowT> FindById(long id);
+
+    protected abstract IEnumerable<RowT> FindAll();
+    #endregion
+
+    protected delegate IEnumerable<RowT> Selector();
+
+    protected ObjT Convert(RowT row, ObjT obj) {
+      try {
+        obj = ConvertRow(row, obj);
+        return obj;
+      }
+      catch (DeletedRowInaccessibleException) {
+        return default(ObjT);
+      }
+      catch (RowNotInTableException) {
+        return default(ObjT);
+      }
+    }
+
+    protected virtual RowT FindSingleRow(Selector selector) {
+      RowT row = default(RowT);
+
+      IEnumerable<RowT> found =
+        selector();
+
+      if (found.Count<RowT>() == 1)
+        row = found.First<RowT>();
+
+      return row;
+    }
+
+    protected virtual ObjT FindSingle(Selector selector) {
+      RowT row = FindSingleRow(selector);
+
+      if (row != null) {
+        ObjT obj = new ObjT();
+        obj = Convert(row, obj);
+
+        return obj;
+      } else {
+        return default(ObjT);
+      }
+    }
+
+    protected virtual ICollection<ObjT> FindMultiple(Selector selector) {
+      IEnumerable<RowT> found =
+        selector();
+
+      IList<ObjT> result =
+        new List<ObjT>();
+
+      foreach (RowT row in found) {
+        ObjT obj = new ObjT();
+        obj = Convert(row, obj);
+        if(obj != null)
+          result.Add(obj);
+      }
+
+      return result;
+    }
+
+    protected virtual RowT GetRowById(long id) {
+      return FindSingleRow(
+        delegate() {
+          return FindById(id);
+        });
+    }
+
+    public virtual void Update(ObjT obj) {
+      if (obj != null) {
+        RowT row = null;
+        long locked = default(long);
+        
+        if (obj.Id != default(long)) {
+           LockRow(obj.Id);
+           locked = obj.Id;
+
+           row = GetRowById(obj.Id);
+        }          
+
+        if (row == null) {
+          row = InsertNewRow(obj);
+          UpdateRow(row);
+
+          obj.Id = (long)row[row.Table.PrimaryKey[0]];
+        }
+
+        if (locked == default(long)) {
+          LockRow(obj.Id);
+          locked = obj.Id;
+        }
+
+        ConvertObj(obj, row);
+        UpdateRow(row);
+
+        UnlockRow(locked);
+      }
+    }
+
+    public virtual ObjT GetById(long id) {
+      return FindSingle(delegate() {
+        return FindById(id);
+      });
+    }
+
+    public virtual ICollection<ObjT> GetAll() {
+      return new List<ObjT>(
+        FindMultiple(
+          new Selector(FindAll)));
+    }
+
+    public virtual bool Delete(ObjT obj) {
+      bool success = false;
+      
+      if (obj != null) {
+        LockRow(obj.Id);
+
+        RowT row =
+          GetRowById(obj.Id);
+
+        if (row != null) {
+          row.Delete();
+          UpdateRow(row);
+
+          success = true;
+        }
+
+        UnlockRow(obj.Id);
+      }
+
+      return success;
+    }
+  }
+}
+
Index: /trunk/sources/HeuristicLab.DataAccess.ADOHelper/HeuristicLab.DataAccess.ADOHelper.csproj
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess.ADOHelper/HeuristicLab.DataAccess.ADOHelper.csproj	(revision 1377)
+++ /trunk/sources/HeuristicLab.DataAccess.ADOHelper/HeuristicLab.DataAccess.ADOHelper.csproj	(revision 1377)
@@ -0,0 +1,86 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.30729</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{5CDACE54-5FB2-4344-A21C-963F63CB7C2B}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.DataAccess.ADOHelper</RootNamespace>
+    <AssemblyName>HeuristicLab.DataAccess.ADOHelper-3.2</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <StartupObject>
+    </StartupObject>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Properties\AssemblyInfo.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="CachedDataAdapter.cs" />
+    <Compile Include="DataAccessADOHelperPlugin.cs" />
+    <Compile Include="DataAdapterBase.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.DataAccess\HeuristicLab.DataAccess.csproj">
+      <Project>{9076697B-C151-46CD-95BC-1D059492B478}</Project>
+      <Name>HeuristicLab.DataAccess</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data" />
+    <Reference Include="System.Data.DataSetExtensions">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data.Linq">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.XML" />
+  </ItemGroup>
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd</PreBuildEvent>
+  </PropertyGroup>
+</Project>
Index: /trunk/sources/HeuristicLab.DataAccess/DBSynchronizer.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess/DBSynchronizer.cs	(revision 1377)
+++ /trunk/sources/HeuristicLab.DataAccess/DBSynchronizer.cs	(revision 1377)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Timers;
+using HeuristicLab.DataAccess.Interfaces;
+
+namespace HeuristicLab.DataAccess {
+  class DBSynchronizer: IDBSynchronizer {
+    private Timer timer =
+      new Timer();
+
+    void timer_Elapsed(object sender, ElapsedEventArgs e) {
+      UpdateDB();
+    }
+
+    #region IDBSynchronizer Members
+    public event EventHandler OnUpdate;
+
+    public void EnableAutoUpdate(TimeSpan interval) {
+      timer.Interval = interval.TotalMilliseconds;
+      timer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
+      timer.Start();
+    }
+
+    public void DisableAutoUpdate() {
+      timer.Stop();
+    }
+
+    public void UpdateDB() {
+      if (OnUpdate != null)
+        OnUpdate(this, null);
+    }
+
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.DataAccess/DataAccessPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess/DataAccessPlugin.cs	(revision 1377)
+++ /trunk/sources/HeuristicLab.DataAccess/DataAccessPlugin.cs	(revision 1377)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.DataAccess {
+  [ClassInfo(Name = "HeuristicLab.DataAccess-3.2")]
+  [PluginFile(Filename = "HeuristicLab.DataAccess-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  public class DataAccessPlugin : PluginBase {
+  }
+}
Index: /trunk/sources/HeuristicLab.DataAccess/HeuristicLab.DataAccess.csproj
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess/HeuristicLab.DataAccess.csproj	(revision 1377)
+++ /trunk/sources/HeuristicLab.DataAccess/HeuristicLab.DataAccess.csproj	(revision 1377)
@@ -0,0 +1,129 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.30729</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{9076697B-C151-46CD-95BC-1D059492B478}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.DataAccess</RootNamespace>
+    <AssemblyName>HeuristicLab.DataAccess-3.2</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+    <PublishUrl>publish\</PublishUrl>
+    <Install>true</Install>
+    <InstallFrom>Disk</InstallFrom>
+    <UpdateEnabled>false</UpdateEnabled>
+    <UpdateMode>Foreground</UpdateMode>
+    <UpdateInterval>7</UpdateInterval>
+    <UpdateIntervalUnits>Days</UpdateIntervalUnits>
+    <UpdatePeriodically>false</UpdatePeriodically>
+    <UpdateRequired>false</UpdateRequired>
+    <MapFileExtensions>true</MapFileExtensions>
+    <ApplicationRevision>0</ApplicationRevision>
+    <ApplicationVersion>1.0.0.%2a</ApplicationVersion>
+    <IsWebBootstrapper>false</IsWebBootstrapper>
+    <UseApplicationTrust>false</UseApplicationTrust>
+    <BootstrapperEnabled>true</BootstrapperEnabled>
+    <StartupObject>
+    </StartupObject>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <ItemGroup>
+    <None Include="Properties\AssemblyInfo.frame" />
+    <None Include="HeuristicLab.snk" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="DataAccessPlugin.cs" />
+    <Compile Include="Interfaces\IDBSynchronizer.cs" />
+    <Compile Include="PersistableObject.cs" />
+    <Compile Include="Interfaces\ICachedDataAdapter.cs" />
+    <Compile Include="Interfaces\IDataAdapter.cs" />
+    <Compile Include="Interfaces\IPersistableObject.cs" />
+    <Compile Include="DBSynchronizer.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Core\HeuristicLab.Core.csproj">
+      <Project>{F43B59AB-2B8C-4570-BC1E-15592086517C}</Project>
+      <Name>HeuristicLab.Core</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd</PreBuildEvent>
+  </PropertyGroup>
+  <ItemGroup>
+    <BootstrapperPackage Include="Microsoft.Net.Client.3.5">
+      <Visible>False</Visible>
+      <ProductName>.NET Framework Client Profile</ProductName>
+      <Install>false</Install>
+    </BootstrapperPackage>
+    <BootstrapperPackage Include="Microsoft.Net.Framework.2.0">
+      <Visible>False</Visible>
+      <ProductName>.NET Framework 2.0 %28x86%29</ProductName>
+      <Install>false</Install>
+    </BootstrapperPackage>
+    <BootstrapperPackage Include="Microsoft.Net.Framework.3.0">
+      <Visible>False</Visible>
+      <ProductName>.NET Framework 3.0 %28x86%29</ProductName>
+      <Install>false</Install>
+    </BootstrapperPackage>
+    <BootstrapperPackage Include="Microsoft.Net.Framework.3.5">
+      <Visible>False</Visible>
+      <ProductName>.NET Framework 3.5</ProductName>
+      <Install>false</Install>
+    </BootstrapperPackage>
+    <BootstrapperPackage Include="Microsoft.Net.Framework.3.5.SP1">
+      <Visible>False</Visible>
+      <ProductName>.NET Framework 3.5 SP1</ProductName>
+      <Install>true</Install>
+    </BootstrapperPackage>
+    <BootstrapperPackage Include="Microsoft.Windows.Installer.3.1">
+      <Visible>False</Visible>
+      <ProductName>Windows Installer 3.1</ProductName>
+      <Install>true</Install>
+    </BootstrapperPackage>
+  </ItemGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Runtime.Serialization">
+      <RequiredTargetFramework>3.0</RequiredTargetFramework>
+    </Reference>
+  </ItemGroup>
+</Project>
Index: /trunk/sources/HeuristicLab.DataAccess/HeuristicLab.DataAccess.csproj.user
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess/HeuristicLab.DataAccess.csproj.user	(revision 1377)
+++ /trunk/sources/HeuristicLab.DataAccess/HeuristicLab.DataAccess.csproj.user	(revision 1377)
@@ -0,0 +1,17 @@
+﻿<Project xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <PublishUrlHistory>publish\</PublishUrlHistory>
+    <InstallUrlHistory>
+    </InstallUrlHistory>
+    <SupportUrlHistory>
+    </SupportUrlHistory>
+    <UpdateUrlHistory>
+    </UpdateUrlHistory>
+    <BootstrapperUrlHistory>
+    </BootstrapperUrlHistory>
+    <ErrorReportUrlHistory>
+    </ErrorReportUrlHistory>
+    <FallbackCulture>en-US</FallbackCulture>
+    <VerifyUploadedFiles>false</VerifyUploadedFiles>
+  </PropertyGroup>
+</Project>
Index: /trunk/sources/HeuristicLab.DataAccess/Interfaces/ICachedDataAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess/Interfaces/ICachedDataAdapter.cs	(revision 1377)
+++ /trunk/sources/HeuristicLab.DataAccess/Interfaces/ICachedDataAdapter.cs	(revision 1377)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Runtime.CompilerServices;
+
+namespace HeuristicLab.DataAccess.Interfaces {
+  public interface ICachedDataAdapter {
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    void SyncWithDb();
+  }
+}
